 Tinit=[369.4310 376.3844 383.8233 391.8714 400.6834 410.4583 421.4572...
    434.0176 448.5350 465.2707 444.9769 461.0420 478.4799 494.4777...
    505.6704 511.7069, 514.4583 515.6106 516.0755 516.2603 498.7332...
    506.8531 509.9740 511.0447 511.3971 511.5115 511.5485 511.5604...
    511.5642 511.5655];
%Tinit=linspace(360,510,30);    % should give upper steady-state; To=511.565
Tinit10=Tinit(1:10);
Tinit20=Tinit(11:20);
Tinit30=Tinit(21:30);
rhoc=2200;  % catalyst bulk density
mc=127*1000/3600;  % flow entering heat exchanger (kg/s)
Qc=mc/rhoc; % volume flow entering heat exchanger [m^3/s] 
Cp=3500;           % gas
Cpc=1100;          % catalyst
%%%%%%%%%%% quench flows (kg/s) %%%%%%%%%%%%%%
Q1=58*1000/3600;   
Q2=35*1000/3600;
Q3=32*1000/3600;
cf=0.08;  % feed mass fraction of ammonia
p=200; %% Reactor pressure [bar]
vol1=6.69; % volume of bed 1
vol2=9.63; % volume of bed 2
vol3=15.2; % volume of bed 3
%%%%%%%%%% No. of discretization points; 10 in each bed%%%%%%%%%%%%
Nbed1=10;
Nbed2=10;
Nbed3=10;
dHrx=2.7e6; % [kJ/kg] Note: 111370 * 28 = 3.118 e6
%%%%%%%%%% mass of catalyst in each bed %%%%%%%%%%%%
dm1=vol1/Nbed1*rhoc;  
dm2=vol2/Nbed2*rhoc;
dm3=vol3/Nbed3*rhoc;
Tfeed=250;% Fresh feed temperature, C
%Mass flows:
% m1=mc+Q1;
% m2=m1+Q2;
% m3=m2+Q3;
%%%%%%%%%% heat exchanger parameters %%%%%%%%%%%%%%
UA=536*283; 
mh=252*1000/3600;  % total feed flow (kg/s)
%%%%%%%%%%%% valve parameters %%%%%%%%%%%%
k0=0.5;
k1=1;
% u1=-0.35;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
wl=0.148;
wh=1000;
%______________________Expected/allowed max. values________________________
% s=tf('s');
% K=-0.228*(1+s);
%__________________End Scaling_____________________________________________
emax=30;
umax=1;
%dmax=50;
% Gscaled=(15/30)*G*0.5;
% %Gdscaled=(1/15)*Gd(2)*35;
% [Gs,Gsu]=stabproj(Gscaled);
% [Gsu_num,Gsu_den]=tfdata(Gsu);
% [z1,p1,k1]=zpkdata(Gsu);
% p_temp1=p1{1};
% z_temp1=z1{1};
% pm1=uminus(p_temp1);
% zm1=uminus(z_temp1);
% Gsu_m=zpk(zm1,pm1,k1);
% pdm1=pole(Gsu_m);
% zdm1=zero(Gsu_m);
% sigma=hankelsv(Gsu_m)
% KSbound=1/sigma(2)
% 
% [Gds,Gdsu]=stabproj(Gdscaled);
% [Gdsu_num,Gdsu_den]=tfdata(Gdsu);
% [zd1,pd1,kd1]=zpkdata(Gdsu);
% pd_temp1=p1{1};
% zd_temp1=z1{1};
% pdm1=uminus(pd_temp1);
% zdm1=uminus(zd_temp1);
% Gdsu_m=zpk(zdm1,pdm1,kd1);
% pdm1=pole(Gdsu_m);
% zdm1=zero(Gdsu_m);
% sigma=hankelsv((Gsu_m)\Gsu_m)


%__________________Kf______________________________________________________
 Kf=Gd_s(2)+Gdm_usN;
 [Kf_num,Kf_den] = tfdata(Kf);


