function Tprime=righthand(t,T)
global mc mh Cp Cpc Q1 Q2 Q3 Npoint Tfeed cf dm1 dm2 dm3 dHrx u conc
% comment: For simplicity we use rx((T(i),c(i-1))
%rather than rx((T(i),c(i))

%Mass flows:
m1=mc+Q1;
m2=m1+Q2;
m3=m2+Q3;
% Conc. in bed 1:
%________________________________________________
c(1)=cf+dm1*reaxion(T(1),cf)/m1;
for i=2:10
  c(i)=c(i-1)+dm1*reaxion(T(i),c(i-1))/m1;
end
% Quench 2:
%________________________________________________
cin2=m1/m2*c(10)+Q2/m2*cf;
% Conc. in bed 2
%________________________________________________
c(11)=cin2+dm2*reaxion(T(11),cin2)/m2;
for i=12:20
  c(i)=c(i-1)+dm2*reaxion(T(i),c(i-1))/m2;
end
% Quench 3:
%________________________________________________
cin3=m2/m3*c(20)+Q3/m3*cf;
% Conc. in bed 3
%________________________________________________
c(21)=cin3+dm3*reaxion(T(21),cin3)/m3;
for i=22:30
    c(i)=c(i-1)+dm3*reaxion(T(i),c(i-1))/m3;
end
% Quench 1:
%________________________________________________
Ti=heatx(T(30),Tfeed); Tin1=mc/m1*Ti+Q1/m1*Tfeed;
% dTdt in bed 1:
%________________________________________________
dTdt(1)=(m1*Cp*(Tin1-T(1))+dm1*reaxion(T(1),cf)*dHrx)/(dm1*Cpc);
for i=2:10
  dTdt(i)=(m1*Cp*(T(i-1)-T(i))+dm1*reaxion(T(i),c(i-1))*dHrx)/(dm1*Cpc);
end
% Quench 2:
%________________________________________________
Tin2=m1/m2*T(10)+Q2/m2*Tfeed;
% dTdt in bed 2:
%________________________________________________
dTdt(11)=(m2*Cp*(Tin2-T(11))+dm2*reaxion(T(11),cin2)*dHrx)/(dm2*Cpc);
for i=12:20
  dTdt(i)=(m2*Cp*(T(i-1)-T(i))+dm2*reaxion(T(i),c(i-1))*dHrx)/(dm2*Cpc);
end
% Quench 3:
%________________________________________________
Tin3=m2/m3*T(20)+Q3/m3*Tfeed;
% dTdt in bed 3:
%________________________________________________
dTdt(21)=(m3*Cp*(Tin3-T(21))+dm3*reaxion(T(21),cin3)*dHrx)/(dm3*Cpc);
for i=22:30
  dTdt(i)=(m3*Cp*(T(i-1)-T(i))+dm3*reaxion(T(i),c(i-1))*dHrx)/(dm3*Cpc);
end
Tprime=dTdt;
Tin=heatx(T(Npoint),Tfeed);
conc=c;
%________________________________________________
